
PrefabFiles = {
	"wx78",
	"healthup",
	"sanityup",
	"hungerup",
	"locomotorup",
	"combatup",
	"locomotordown",
	"combatdown",
	"pencil",
	"status",
}


local STRINGS = GLOBAL.STRINGS

STRINGS.TABS.UPGRADES = "Upgrades"


STRINGS.NAMES.HEALTHUP = "Armor Plating Module"
STRINGS.NAMES.SANITYUP = "CPU Module"
STRINGS.NAMES.HUNGERUP = "Fuel Reserves Module"
STRINGS.NAMES.LOCOMOTORUP = "L.S.M"
STRINGS.NAMES.COMBATUP = "E.C.M"
STRINGS.NAMES.COMBATDOWN = "E.C.M Removal Kit"
STRINGS.NAMES.LOCOMOTORDOWN = "L.S.M Removal Kit"
STRINGS.NAMES.STATUS = "Upgrade Notebook"
STRINGS.NAMES.PENCIL = "Pencil"


STRINGS.RECIPE_DESC.HEALTHUP = "Extra armor. Better survival."
STRINGS.RECIPE_DESC.SANITYUP = "Reality. Now in HD."
STRINGS.RECIPE_DESC.HUNGERUP = "More fuel, less death by starvation."
STRINGS.RECIPE_DESC.LOCOMOTORUP = "Run faster, burn more calories."
STRINGS.RECIPE_DESC.COMBATUP = "*The best defense is a strong offense*."
STRINGS.RECIPE_DESC.COMBATDOWN ="Revert changes done to the Combat System."
STRINGS.RECIPE_DESC.LOCOMOTORDOWN ="Revert changes done to Locomotion."
STRINGS.RECIPE_DESC.STATUS = "Your very own notebook."
STRINGS.RECIPE_DESC.PENCIL = "You'll need it for your notebook."

local option = GetModConfigData("opt")


STRINGS.CHARACTERS.WX78.DESCRIBE.HEALTHUP = "WITH THIS I SHALL BECOME... LESS VINCIBLE"
STRINGS.CHARACTERS.WX78.DESCRIBE.SANITYUP = "I'LL MAKE MY OWN CPU. WITH BLACKJACK AND... WAIT"
STRINGS.CHARACTERS.WX78.DESCRIBE.HUNGERUP = "MY CHEMICAL ENGINE WILL ENJOY THIS"
STRINGS.CHARACTERS.WX78.DESCRIBE.LOCOMOTORUP = "FASTER IS NOT *ALWAYS* BETTER...OR SO HUMANS SAY"
STRINGS.CHARACTERS.WX78.DESCRIBE.COMBATUP = "THE FLESHLINGS WILL LOVE THIS"
STRINGS.CHARACTERS.WX78.DESCRIBE.LOCOMOTORDOWN = "FASTER_IS_NOT_ALWAYS_BETTER (TRUE)"
STRINGS.CHARACTERS.WX78.DESCRIBE.COMBATDOWN = "ADAPTABILITY IS ESSENTIAL TO SURVIVAL"
STRINGS.CHARACTERS.WX78.DESCRIBE.STATUS = "PRIMITIVE DATA STORAGE UNIT. GOOD FOR CREATING PAPER AIRCRAFT"
STRINGS.CHARACTERS.WX78.DESCRIBE.PENCIL = "PRIMITIVE INPUT TOOL"


TUNING.WX78_MAX_HEALTH = 300
TUNING.WX78_MAX_HUNGER = 250
TUNING.WX78_MAX_SANITY = 200

TUNING.WX78_OVERHAUL = option

TUNING.WX78_MAX_SPEED = 9



local player = GLOBAL.GetPlayer()



local function ApplyHealthUpgrade(player)

	local max_health_upgrades = 10
	local health_upgrades = math.min (player.health_level , max_health_upgrades)
	local health_percent = player.components.health:GetPercent()

	if 	player.components.health.maxhealth < 100 and (player.WX_Max_Health - TUNING.WX78_MIN_HEALTH - player.components.health.maxhealth)>0 and player.combat_level ~= 0 then
		player.components.health.maxhealth = player.components.health.maxhealth + health_upgrades* math.ceil((player.WX_Max_Health - TUNING.WX78_MIN_HEALTH - player.components.health.maxhealth)/max_health_upgrades)
		player.components.health:SetPercent(health_percent) 
	
	else
		player.components.health.maxhealth = math.ceil(TUNING.WX78_MIN_HEALTH + health_upgrades* (player.WX_Max_Health - TUNING.WX78_MIN_HEALTH)/max_health_upgrades)
		player.components.health:SetPercent(health_percent)
	end
	
end

local function ApplySanityUpgrade(player)

	local max_sanity_upgrades = 10
	local sanity_upgrades = math.min (player.sanity_level , max_sanity_upgrades)

	local sanity_percent = player.components.sanity:GetPercent()

	
	player.components.sanity.max = math.ceil(TUNING.WX78_MIN_SANITY + sanity_upgrades* (TUNING.WX78_MAX_SANITY - TUNING.WX78_MIN_SANITY)/max_sanity_upgrades)
	player.components.sanity:SetPercent(sanity_percent)

end

local function ApplyHungerUpgrade(player)

	local max_hunger_upgrades = 10
	local hunger_upgrades = math.min(player.hunger_level , max_hunger_upgrades)

	local hunger_percent = player.components.hunger:GetPercent()

	player.components.hunger.max = math.ceil(TUNING.WX78_MIN_HUNGER + hunger_upgrades* (TUNING.WX78_MAX_HUNGER - TUNING.WX78_MIN_HUNGER)/max_hunger_upgrades)
	
	player.components.hunger:SetPercent(hunger_percent)

end

local function ApplyLocomotorUpgrade (player)
	local max_locomotor_upgrades = 5
	local locomotor_upgrades = math.min (player.locomotor_level , max_locomotor_upgrades)

	player.WX_Current_Run_Speed =  (TUNING.WILSON_RUN_SPEED + locomotor_upgrades*(TUNING.WX78_MAX_SPEED -TUNING.WILSON_RUN_SPEED )/max_locomotor_upgrades)
	
	player.components.locomotor.runspeed = player.WX_Current_Run_Speed
	
	if player.locomotor_level < 6 then
		player.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE + (locomotor_upgrades* (TUNING.WILSON_HUNGER_RATE * 0.20)))
	end	
end

local function ApplyCombatUpgrade (player)
	local max_combat_upgrades = 5
	local combat_upgrades = math.min (player.combat_level , max_combat_upgrades)
	player.components.combat.damagemultiplier = (TUNING.WOLFGANG_ATTACKMULT_NORMAL + combat_upgrades * ((TUNING.WOLFGANG_ATTACKMULT_MIGHTY_MAX - TUNING.WOLFGANG_ATTACKMULT_NORMAL)/(max_combat_upgrades*2)))
 	local health_percent = player.components.health:GetPercent()
 	player.WX_Max_Health = TUNING.WX78_MAX_HEALTH - (combat_upgrades * (TUNING.WX78_MAX_HEALTH*0.10))
 	if player.combat_level < 6 then
 		player.components.health.maxhealth = player.components.health.maxhealth - ((TUNING.WX78_MAX_HEALTH-TUNING.WX78_MIN_HEALTH) * 0.15)
 	end
 	player.components.health:SetPercent(health_percent)
end

local function ApplyCombatDowngrade (player)
	local max_combat_upgrades = 5
	local combat_upgrades = math.min (player.combat_level , max_combat_upgrades)
	player.components.combat.damagemultiplier = (TUNING.WOLFGANG_ATTACKMULT_NORMAL + combat_upgrades * ((TUNING.WOLFGANG_ATTACKMULT_MIGHTY_MAX - TUNING.WOLFGANG_ATTACKMULT_NORMAL)/(max_combat_upgrades*2)))
 	local health_percent = player.components.health:GetPercent()
 	player.WX_Max_Health = TUNING.WX78_MAX_HEALTH - (combat_upgrades * (TUNING.WX78_MAX_HEALTH*0.10))
 	if player.combat_level < 6 then
 		player.components.health.maxhealth = player.components.health.maxhealth + ((TUNING.WX78_MAX_HEALTH-TUNING.WX78_MIN_HEALTH) * 0.15)
 	end
 	player.components.health:SetPercent(health_percent)
end


local function oneat(player, food)

	if food and food.components.edible and food.components.edible.foodtype == "GEARS" then
			player.components.talker:Say("srs?")
	end
	if food and food.components.edible and food.components.edible.foodtype == "HEALTHUP" then
		--give an upgrade!
		if player.health_level < 10 then
			player.health_level = player.health_level + 1
			player.level = player.level + 15
			ApplyHealthUpgrade(player)	
			player.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
			player.HUD.controls.status.heart:PulseGreen()
			player.HUD.controls.status.heart:ScaleTo(1.3,1,.7)
		else
			player.components.talker:Say("AT CAPACITY. UPGRADE FAILED")
		end

	end

	if food and food.components.edible and food.components.edible.foodtype == "SANITYUP" then
		--give an upgrade!
		if player.sanity_level < 10 then 
			player.sanity_level = player.sanity_level + 1
			player.level = player.level + 1
			ApplySanityUpgrade(player)	
			player.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
			player.HUD.controls.status.brain:PulseGreen()
			player.HUD.controls.status.brain:ScaleTo(1.3,1,.7)
		else
			player.components.talker:Say("AT CAPACITY. UPGRADE FAILED")
		end
	end

	if food and food.components.edible and food.components.edible.foodtype == "HUNGERUP" then
		--give an upgrade!
		if player.hunger_level < 10 then
			player.hunger_level = player.hunger_level + 1
			player.level = player.level + 1
			ApplyHungerUpgrade(player)	
			player.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
			player.HUD.controls.status.stomach:PulseGreen()
			player.HUD.controls.status.stomach:ScaleTo(1.3,1,.7)
		else
			player.components.talker:Say("AT CAPACITY. UPGRADE FAILED")
		end
	end

	if food and food.components.edible and food.components.edible.foodtype == "LOCOMOTORUP" then
		--give an upgrade!
		if player.locomotor_level < 5 then
			player.locomotor_level=player.locomotor_level + 1
			ApplyLocomotorUpgrade(player)	
			player.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
		else
			player.components.talker:Say("AT CAPACITY. UPGRADE FAILED")
		end

		
	end

	if food and food.components.edible and food.components.edible.foodtype == "COMBATUP" then
		--give an upgrade!
		if player.combat_level < 5 then 
			player.combat_level = player.combat_level + 1
			ApplyCombatUpgrade(player)	
			player.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
		else
			player.components.talker:Say("AT CAPACITY. UPGRADE FAILED")
		end
	end

	if food and food.components.edible and food.components.edible.foodtype == "LOCOMOTORDOWN" then
		--give an upgrade!

		if player.locomotor_level > 0 then 
		player.locomotor_level = player.locomotor_level -1 
		ApplyLocomotorUpgrade(player)	
		player.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
		else
			player.components.talker:Say("DOWNGRADE FAILED. NO UPGRADE DETECTED")
		end
	end

	if food and food.components.edible and food.components.edible.foodtype == "COMBATDOWN" then
		--give an upgrade!
		if player.combat_level > 0 then 
		player.combat_level = player.combat_level -1 
		ApplyCombatDowngrade(player)	
		player.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
		else
			player.components.talker:Say("DOWNGRADE FAILED. NO UPGRADE DETECTED")
		end
	end	
end

AddPrefabPostInit("wx78", function(player) 
    print("prefab "..tostring(player.prefab).." postinit called")
	player.components.eater:SetOnEatFn(oneat)
   	print (tostring(player.level))
end)


AddPrefabPostInit("healthup", function(player) 
   	print (tostring(player.level))
end)