local assets =
{
	Asset("ANIM", "anim/status.zip"),
	Asset("IMAGE", "images/inventoryimages/status.tex"),
	Asset("ATLAS", "images/inventoryimages/status.xml"),
}
    

    
function statusfn (inst,reader)
    local health_level = math.min (reader.health_level,10)
    local sanity_level = math.min (reader.sanity_level,10)
    local hunger_level = math.min (reader.hunger_level,10)
    local locomotor_level = math.min (reader.locomotor_level , 5)
    local combat_level = math.min (reader.combat_level , 5)
    health_level = tostring(health_level)
    sanity_level=tostring(sanity_level)
    hunger_level=tostring(hunger_level)
    locomotor_level=tostring(locomotor_level)
    combat_level=tostring(combat_level)
    local str = "Armor " .. health_level .. "/10" ..  "\n" .. "Sanity " .. sanity_level .. "/10" .. "\n" .. "Hunger " .. hunger_level .."/10" .. "\n" .. "Locomotor " .. locomotor_level .."/5" .. "\n" .. "Combat " .. combat_level .."/5" 
    reader.components.talker:Say(str)
   return true
end  
local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
    
    inst.AnimState:SetBank("moditem")
    inst.AnimState:SetBuild("status")
    inst.AnimState:PlayAnimation("idle")


    inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM
 
    inst:AddComponent("inspectable")  
    
    inst:AddComponent("inventoryitem")      
	inst.components.inventoryitem.atlasname = "images/inventoryimages/status.xml"

    inst:AddComponent("fuel")
    inst.components.fuel.fuelvalue = TUNING.SMALL_FUEL
    
    MakeSmallBurnable(inst, TUNING.SMALL_BURNTIME)
    MakeSmallPropagator(inst)

    inst:AddComponent("book")
    inst.components.book.onread = statusfn

    return inst 
    end 
    return Prefab("common/inventory/status", fn, assets) 


