
local MakePlayerCharacter = require "prefabs/player_common"


local assets = 
{
    Asset("ANIM", "anim/wx78.zip"),
	Asset("SOUND", "sound/wx78.fsb") 
	
}

local prefabs = 
{
	"sparks"
}
--hunger, health, sanity
local function applyupgrades(inst)

	local max_upgrades = 15
	local upgrades = math.min(inst.level, max_upgrades)

	local hunger_percent = inst.components.hunger:GetPercent()
	local health_percent = inst.components.health:GetPercent()
	local sanity_percent = inst.components.sanity:GetPercent()

	inst.components.hunger.max = math.ceil(TUNING.WX78_MIN_HUNGER + upgrades* (TUNING.WX78_MAX_HUNGER - TUNING.WX78_MIN_HUNGER)/max_upgrades)
	inst.components.health.maxhealth = math.ceil(TUNING.WX78_MIN_HEALTH + upgrades* (TUNING.WX78_MAX_HEALTH - TUNING.WX78_MIN_HEALTH)/max_upgrades)
	inst.components.sanity.max = math.ceil(TUNING.WX78_MIN_SANITY + upgrades* (TUNING.WX78_MAX_SANITY - TUNING.WX78_MIN_SANITY)/max_upgrades)

	inst.components.hunger:SetPercent(hunger_percent)
	inst.components.health:SetPercent(health_percent)
	inst.components.sanity:SetPercent(sanity_percent)
	
end
local function ApplyHealthUpgrade(inst)

	local max_health_upgrades = 10
	local health_upgrades = math.min (inst.health_level , max_health_upgrades)
	local health_percent = inst.components.health:GetPercent()

	if 	inst.components.health.maxhealth < 100 and (inst.WX_Max_Health - TUNING.WX78_MIN_HEALTH - inst.components.health.maxhealth)>0 and inst.combat_level ~= 0 then
		inst.components.health.maxhealth = inst.components.health.maxhealth + health_upgrades* math.ceil((inst.WX_Max_Health - TUNING.WX78_MIN_HEALTH - inst.components.health.maxhealth)/max_health_upgrades)
		inst.components.health:SetPercent(health_percent) 
	
	else
		inst.components.health.maxhealth = math.ceil(TUNING.WX78_MIN_HEALTH + health_upgrades* (inst.WX_Max_Health - TUNING.WX78_MIN_HEALTH)/max_health_upgrades)
		inst.components.health:SetPercent(health_percent)
	end
	
end

local function ApplySanityUpgrade(inst)

	local max_sanity_upgrades = 10
	local sanity_upgrades = math.min (inst.sanity_level , max_sanity_upgrades)

	local sanity_percent = inst.components.sanity:GetPercent()

	
	inst.components.sanity.max = math.ceil(TUNING.WX78_MIN_SANITY + sanity_upgrades* (TUNING.WX78_MAX_SANITY - TUNING.WX78_MIN_SANITY)/max_sanity_upgrades)
	inst.components.sanity:SetPercent(sanity_percent)

end

local function ApplyHungerUpgrade(inst)

	local max_hunger_upgrades = 10
	local hunger_upgrades = math.min(inst.hunger_level , max_hunger_upgrades)

	local hunger_percent = inst.components.hunger:GetPercent()

	inst.components.hunger.max = math.ceil(TUNING.WX78_MIN_HUNGER + hunger_upgrades* (TUNING.WX78_MAX_HUNGER - TUNING.WX78_MIN_HUNGER)/max_hunger_upgrades)
	
	inst.components.hunger:SetPercent(hunger_percent)

end

local function ApplyLocomotorUpgrade (inst)
	local max_locomotor_upgrades = 5
	local locomotor_upgrades = math.min (inst.locomotor_level , max_locomotor_upgrades)

	inst.WX_Current_Run_Speed =  (TUNING.WILSON_RUN_SPEED + locomotor_upgrades*(TUNING.WX78_MAX_SPEED -TUNING.WILSON_RUN_SPEED )/max_locomotor_upgrades)
	
	inst.components.locomotor.runspeed = inst.WX_Current_Run_Speed
	
	if inst.locomotor_level < 6 then
		inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE + (locomotor_upgrades* (TUNING.WILSON_HUNGER_RATE * 0.20)))
	end	
end

local function ApplyCombatUpgrade (inst)
	local max_combat_upgrades = 5
	local combat_upgrades = math.min (inst.combat_level , max_combat_upgrades)
	inst.components.combat.damagemultiplier = (TUNING.WOLFGANG_ATTACKMULT_NORMAL + combat_upgrades * ((TUNING.WOLFGANG_ATTACKMULT_MIGHTY_MAX - TUNING.WOLFGANG_ATTACKMULT_NORMAL)/(max_combat_upgrades*2)))
 	local health_percent = inst.components.health:GetPercent()
 	inst.WX_Max_Health = TUNING.WX78_MAX_HEALTH - (combat_upgrades * (TUNING.WX78_MAX_HEALTH*0.10))
 	if inst.combat_level < 6 then
 		inst.components.health.maxhealth = inst.components.health.maxhealth - ((TUNING.WX78_MAX_HEALTH-TUNING.WX78_MIN_HEALTH) * 0.15)
 	end
 	inst.components.health:SetPercent(health_percent)
end

local function ApplyCombatDowngrade (inst)
	local max_combat_upgrades = 5
	local combat_upgrades = math.min (inst.combat_level , max_combat_upgrades)
	inst.components.combat.damagemultiplier = (TUNING.WOLFGANG_ATTACKMULT_NORMAL + combat_upgrades * ((TUNING.WOLFGANG_ATTACKMULT_MIGHTY_MAX - TUNING.WOLFGANG_ATTACKMULT_NORMAL)/(max_combat_upgrades*2)))
 	local health_percent = inst.components.health:GetPercent()
 	inst.WX_Max_Health = TUNING.WX78_MAX_HEALTH - (combat_upgrades * (TUNING.WX78_MAX_HEALTH*0.10))
 	if inst.combat_level < 6 then
 		inst.components.health.maxhealth = inst.components.health.maxhealth + ((TUNING.WX78_MAX_HEALTH-TUNING.WX78_MIN_HEALTH) * 0.15)
 	end
 	inst.components.health:SetPercent(health_percent)
end


local function oneat(inst, food)

	if food and food.components.edible and food.components.edible.foodtype == "GEARS" then
			inst.components.talker:Say("srs?")
	end
	if food and food.components.edible and food.components.edible.foodtype == "HEALTHUP" then
		--give an upgrade!
		if inst.health_level < 10 then
			inst.health_level = inst.health_level + 1
			inst.level = inst.level + 15
			ApplyHealthUpgrade(inst)	
			inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
			inst.HUD.controls.status.heart:PulseGreen()
			inst.HUD.controls.status.heart:ScaleTo(1.3,1,.7)
		else
			inst.components.talker:Say("AT CAPACITY. UPGRADE FAILED")
		end

	end

	if food and food.components.edible and food.components.edible.foodtype == "SANITYUP" then
		--give an upgrade!
		if inst.sanity_level < 10 then 
			inst.sanity_level = inst.sanity_level + 1
			inst.level = inst.level + 1
			ApplySanityUpgrade(inst)	
			inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
			inst.HUD.controls.status.brain:PulseGreen()
			inst.HUD.controls.status.brain:ScaleTo(1.3,1,.7)
		else
			inst.components.talker:Say("AT CAPACITY. UPGRADE FAILED")
		end
	end

	if food and food.components.edible and food.components.edible.foodtype == "HUNGERUP" then
		--give an upgrade!
		if inst.hunger_level < 10 then
			inst.hunger_level = inst.hunger_level + 1
			inst.level = inst.level + 1
			ApplyHungerUpgrade(inst)	
			inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
			inst.HUD.controls.status.stomach:PulseGreen()
			inst.HUD.controls.status.stomach:ScaleTo(1.3,1,.7)
		else
			inst.components.talker:Say("AT CAPACITY. UPGRADE FAILED")
		end
	end

	if food and food.components.edible and food.components.edible.foodtype == "LOCOMOTORUP" then
		--give an upgrade!
		if inst.locomotor_level < 5 then
			inst.locomotor_level=inst.locomotor_level + 1
			ApplyLocomotorUpgrade(inst)	
			inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
		else
			inst.components.talker:Say("AT CAPACITY. UPGRADE FAILED")
		end

		
	end

	if food and food.components.edible and food.components.edible.foodtype == "COMBATUP" then
		--give an upgrade!
		if inst.combat_level < 5 then 
			inst.combat_level = inst.combat_level + 1
			ApplyCombatUpgrade(inst)	
			inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
		else
			inst.components.talker:Say("AT CAPACITY. UPGRADE FAILED")
		end
	end

	if food and food.components.edible and food.components.edible.foodtype == "LOCOMOTORDOWN" then
		--give an upgrade!

		if inst.locomotor_level > 0 then 
		inst.locomotor_level = inst.locomotor_level -1 
		ApplyLocomotorUpgrade(inst)	
		inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
		else
			inst.components.talker:Say("DOWNGRADE FAILED. NO UPGRADE DETECTED")
		end
	end

	if food and food.components.edible and food.components.edible.foodtype == "COMBATDOWN" then
		--give an upgrade!
		if inst.combat_level > 0 then 
		inst.combat_level = inst.combat_level -1 
		ApplyCombatDowngrade(inst)	
		inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
		else
			inst.components.talker:Say("DOWNGRADE FAILED. NO UPGRADE DETECTED")
		end
	end	
end

local function onupdate(inst, dt)
	inst.charge_time = inst.charge_time - dt
	if inst.charge_time <= 0 then
		inst.charge_time = 0
		if inst.charged_task then
			inst.charged_task:Cancel()
			inst.charged_task = nil
		end
		inst.SoundEmitter:KillSound("overcharge_sound")
		inst.charged_task = nil
		inst.Light:Enable(false)
		inst.components.locomotor.runspeed = inst.WX_Current_Run_Speed
		inst.AnimState:SetBloomEffectHandle( "" )
		inst.components.temperature.mintemp = -20
		inst.components.talker:Say(GetString("wx78", "ANNOUNCE_DISCHARGE"))
		--inst.SoundEmitter:KillSound("overcharge_sound")
	else
    	local runspeed_bonus = .5
    	local rad = 3
    	if inst.charge_time < 60 then
    		rad = math.max(.1, rad * (inst.charge_time / 60))
    		runspeed_bonus = (inst.charge_time / 60)*runspeed_bonus
    	end

    	inst.Light:Enable(true)
    	inst.Light:SetRadius(rad)
		inst.components.locomotor.runspeed = inst.WX_Current_Run_Speed*(.8+runspeed_bonus)
		inst.components.temperature.mintemp = 10
	end

end

local function onpreload(inst,data)
	if data then
		if data.level then
			inst.flexibleUpgrades = data.ifu
			inst.level = data.level
			if inst.level > 0 and inst.flexibleUpgrades == nil then
				
				inst.health_level = math.ceil (math.min(inst.level ,30) / 3)
				inst.sanity_level = math.ceil (math.min(inst.level ,30) / 3)
				inst.hunger_level = math.ceil (math.min(inst.level ,30) / 3)
				inst.flexibleUpgrades = 1
				if inst.level > 30 then
					inst.combat_level = math.floor ((inst.level - 30) / 6)
					if (inst.combat_level > 5) then inst.combat_level = 5 end
					inst.locomotor_level = math.floor ((inst.level - 30) / 6)
					if (inst.locomotor_level > 5) then inst.locomotor_level = 5 end

					ApplyCombatUpgrade(inst)
					ApplyLocomotorUpgrade(inst)
					data.combat_level = inst.combat_level
					data.locomotor_level = inst.locomotor_level
				end



				ApplySanityUpgrade(inst)
				ApplyHungerUpgrade(inst)
				ApplyHealthUpgrade(inst)
				
				
				
				data.health_level = inst.health_level
				data.hunger_level = inst.hunger_level
				data.sanity_level = inst.sanity_level
			
			end	
		end
		if data.health_level and data.locomotor_level then		
				inst.health_level=data.health_level
				inst.sanity_level=data.sanity_level
				inst.hunger_level=data.hunger_level
				inst.locomotor_level=data.locomotor_level
				inst.combat_level=data.combat_level
			
				ApplyCombatUpgrade(inst)
				ApplyHealthUpgrade(inst)
				ApplyHungerUpgrade(inst)
				ApplyLocomotorUpgrade(inst)
				ApplySanityUpgrade(inst)
		end
			
			
	
			--re-set these from the save data, because of load-order clipping issues
			if data.health and data.health.health then inst.components.health.currenthealth = data.health.health end
			if data.hunger and data.hunger.hunger then inst.components.hunger.current = data.hunger.hunger end
			if data.sanity and data.sanity.current then inst.components.sanity.current = data.sanity.current end
			inst.components.health:DoDelta(0)
			inst.components.hunger:DoDelta(0)
			inst.components.sanity:DoDelta(0)
			
		end

		if data.charge_time then
			inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )

			onupdate(inst, 0)
			inst.charged_task = inst:DoPeriodicTask(1, onupdate, nil, 1)
		end
end

local function onload(inst, data)
	if data then
		if data.charge_time then
			inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )

			onupdate(inst, 0)
			inst.charged_task = inst:DoPeriodicTask(1, onupdate, nil, 1)
		end

	end
end


local function onsave(inst, data)
	data.ifu = inst.flexibleUpgrades
	data.level = inst.level
	data.health_level = inst.health_level
	data.hunger_level = inst.hunger_level
	data.sanity_level = inst.sanity_level
	data.locomotor_level = inst.locomotor_level
	data.combat_level = inst.combat_level
	data.charge_time = inst.charge_time
end


local function onlightingstrike(inst)
	if inst.components.health and not inst.components.health:IsDead() then
		local protected = false
	    if GetPlayer().components.inventory:IsInsulated() then
	        protected = true
	    end

	    if not protected then
			inst.charge_time = inst.charge_time + TUNING.TOTAL_DAY_TIME*(.5 + .5*math.random())

			inst.sg:GoToState("electrocute")
			inst.components.health:DoDelta(TUNING.HEALING_SUPERHUGE,false,"lightning")
			inst.components.sanity:DoDelta(-TUNING.SANITY_LARGE)
			inst.components.talker:Say(GetString("wx78", "ANNOUNCE_CHARGE"))

			inst.SoundEmitter:KillSound("overcharge_sound")
			inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/charged", "overcharge_sound")
			inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
			
			if not inst.charged_task then
				onupdate(inst, 0)
				inst.charged_task = inst:DoPeriodicTask(1, onupdate, nil, 1)
			end
		else
			inst:PushEvent("lightningdamageavoided")
		end
	end
end

local function dorainsparks(inst, dt)

    if (inst.components.moisture and inst.components.moisture:GetMoisture() > 0) then
    	inst.spark_time = inst.spark_time - dt

    	if inst.spark_time <= 0 then
    		
    		--GetClock():DoLightningLighting()
    		inst.spark_time = 3+math.random()*2

    		local pos = Vector3(inst.Transform:GetWorldPosition())
    		local damage = nil

    		-- Raining, no moisture-giving equipment on head, and moisture is increasing. Pro-rate damage based on waterproofness.
    		if GetSeasonManager():IsRaining() and inst.components.inventory:GetEquippedMoistureRate(EQUIPSLOTS.HEAD) <= 0 and inst.components.moisture:GetDelta() > 0 then
	    		local waterproofmult = (inst.components.moisture and inst.components.moisture.sheltered and inst.components.inventory) and (1 - (inst.components.inventory:GetWaterproofness() + inst.components.moisture.shelter_waterproofness)) or (inst.components.inventory and (1 - inst.components.inventory:GetWaterproofness()) or 1)
	    		damage = waterproofmult > 0 and math.min(TUNING.WX78_MIN_MOISTURE_DAMAGE, TUNING.WX78_MAX_MOISTURE_DAMAGE * waterproofmult) or 0
	    		inst.components.health:DoDelta(damage, false, "rain")
				pos.y = pos.y + 1 + math.random()*1.5
	    	else -- We have moisture-giving equipment on our head or it is not raining and we are just passively wet (but drying off). Do full damage.
	    		if inst.components.moisture:GetDelta() >= 0 then -- Moisture increasing (wearing something moisturizing)
	    			inst.components.health:DoDelta(TUNING.WX78_MAX_MOISTURE_DAMAGE, false, "water")
	    		else -- Drying damage
	    			inst.components.health:DoDelta(TUNING.WX78_MOISTURE_DRYING_DAMAGE, false, "water")
	    		end
				pos.y = pos.y + .25 + math.random()*2
	    	end
			
			if not damage or (damage and damage < 0) then
				local spark = SpawnPrefab("sparks")
				spark.Transform:SetPosition(pos:Get())
			end
    	end
    end

end


local function SCCreate(tab)
	local healthup = Recipe("healthup", {Ingredient("gears", 2),Ingredient("marble", 4),Ingredient ("rope", 4)}, tab, {SCIENCE = 1, MAGIC = 0, ANCIENT = 0},nil,nil,nil,5)
	healthup.atlas = "images/inventoryimages/healthup.xml"

	local sanityup = Recipe("sanityup", {Ingredient("gears", 2) , Ingredient("goldnugget", 5) , Ingredient ("nitre", 12)}, tab, {SCIENCE = 1, MAGIC = 0, ANCIENT = 0},nil,nil,nil,5)
	sanityup.atlas = "images/inventoryimages/sanityup.xml"

	local hungerup = Recipe("hungerup", {Ingredient("gears", 2) , Ingredient ("goldnugget", 5) , Ingredient ("trunk_summer", 2)}, tab, {SCIENCE = 1, MAGIC = 0, ANCIENT = 0},nil,nil,nil,5)
	hungerup.atlas = "images/inventoryimages/hungerup.xml"

	local locomotorup = Recipe("locomotorup", {Ingredient("gears", 2), Ingredient ("beefalowool", 2) , Ingredient ("rabbit", 1)}, tab, {SCIENCE = 2, MAGIC = 0, ANCIENT = 0})
	locomotorup.atlas = "images/inventoryimages/locomotorup.xml"

	local combatup = Recipe("combatup", {Ingredient("gears", 2) , Ingredient ("tentaclespike", 1) , Ingredient("stinger", 2)}, tab, {SCIENCE = 2, MAGIC = 0, ANCIENT = 0})
	combatup.atlas = "images/inventoryimages/combatup.xml"

	local locomotordown = Recipe("locomotordown", {Ingredient("gears", 3), Ingredient ("nightmarefuel", 3) , Ingredient ("beardhair", 1)}, tab, {SCIENCE = 2, MAGIC = 0, ANCIENT = 0})
	locomotordown.atlas = "images/inventoryimages/locomotordown.xml"

	local combatdown = Recipe("combatdown", {Ingredient("gears", 3) , Ingredient ("nightmarefuel", 2) , Ingredient ("beardhair", 2)}, tab, {SCIENCE = 2, MAGIC = 0, ANCIENT = 0})
	combatdown.atlas = "images/inventoryimages/combatdown.xml"
	
	local pencilR = Recipe ("pencil", {Ingredient ("twigs",2), Ingredient ("charcoal",1)}, tab, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0})
	pencilR.atlas = "images/inventoryimages/pencil.xml"

	local pencil = Ingredient("pencil", 1, "images/inventoryimages/pencil.xml")

	local status = Recipe("status", {Ingredient ("papyrus",2), pencil}, tab, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0})
	status.atlas = "images/inventoryimages/status.xml"

	return tab
end


local function HCCreate(tab)
	local healthup = Recipe("healthup", {Ingredient("gears", 1),Ingredient("marble", 2),Ingredient ("rope", 1)}, tab, {SCIENCE = 1, MAGIC = 0, ANCIENT = 0})
	healthup.atlas = "images/inventoryimages/healthup.xml"

	local sanityup = Recipe("sanityup", {Ingredient("gears", 1) , Ingredient("goldnugget", 2) , Ingredient ("nitre", 3)}, tab, {SCIENCE = 1, MAGIC = 0, ANCIENT = 0})
	sanityup.atlas = "images/inventoryimages/sanityup.xml"

	local hungerup = Recipe("hungerup", {Ingredient("gears", 1) , Ingredient ("goldnugget", 1) , Ingredient ("trunk_summer", 1)}, tab, {SCIENCE = 1, MAGIC = 0, ANCIENT = 0},nil,nil,nil,2)
	hungerup.atlas = "images/inventoryimages/hungerup.xml"

	local locomotorup = Recipe("locomotorup", {Ingredient("gears", 2), Ingredient ("beefalowool", 2) , Ingredient ("rabbit", 1)}, tab, {SCIENCE = 2, MAGIC = 0, ANCIENT = 0})
	locomotorup.atlas = "images/inventoryimages/locomotorup.xml"

	local combatup = Recipe("combatup", {Ingredient("gears", 2) , Ingredient ("tentaclespike", 1) , Ingredient("stinger", 2)}, tab, {SCIENCE = 2, MAGIC = 0, ANCIENT = 0})
	combatup.atlas = "images/inventoryimages/combatup.xml"

	local locomotordown = Recipe("locomotordown", {Ingredient("gears", 3), Ingredient ("nightmarefuel", 3) , Ingredient ("beardhair", 1)}, tab, {SCIENCE = 2, MAGIC = 0, ANCIENT = 0})
	locomotordown.atlas = "images/inventoryimages/locomotordown.xml"

	local combatdown = Recipe("combatdown", {Ingredient("gears", 3) , Ingredient ("nightmarefuel", 2) , Ingredient ("beardhair", 2)}, tab, {SCIENCE = 2, MAGIC = 0, ANCIENT = 0})
	combatdown.atlas = "images/inventoryimages/combatdown.xml"
	
	local pencilR = Recipe ("pencil", {Ingredient ("twigs",2), Ingredient ("charcoal",1)}, tab, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0})
	pencilR.atlas = "images/inventoryimages/pencil.xml"

	local pencil = Ingredient("pencil", 1, "images/inventoryimages/pencil.xml")

	local status = Recipe("status", {Ingredient ("papyrus",2), pencil}, tab, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0})
	status.atlas = "images/inventoryimages/status.xml"


	return tab
end

local function TESTCreate(tab)
	local healthup = Recipe("healthup", {Ingredient("gears", 1)}, tab, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0},nil,nil,nil,15)
		healthup.atlas = "images/inventoryimages/healthup.xml"

	local sanityup = Recipe("sanityup", {Ingredient("gears", 1)}, tab, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0},nil,nil,nil,15)
		sanityup.atlas = "images/inventoryimages/sanityup.xml"

	local hungerup = Recipe("hungerup", {Ingredient("gears", 1)}, tab, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0},nil,nil,nil,15)
	hungerup.atlas = "images/inventoryimages/hungerup.xml"

	local locomotorup = Recipe("locomotorup", {Ingredient("gears", 1)}, tab, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0},nil,nil,nil,15)
	locomotorup.atlas = "images/inventoryimages/locomotorup.xml"

	local combatup = Recipe("combatup", {Ingredient("gears", 1)}, tab, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0},nil,nil,nil,15)
	combatup.atlas = "images/inventoryimages/combatup.xml"

	local locomotordown = Recipe("locomotordown", {Ingredient("gears", 1)}, tab, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0},nil,nil,nil,15)
	locomotordown.atlas = "images/inventoryimages/locomotordown.xml"

	local combatdown = Recipe("combatdown", {Ingredient("gears", 1)}, tab, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0},nil,nil,nil,15)
	combatdown.atlas = "images/inventoryimages/combatdown.xml"

	local pencilR = Recipe ("pencil", {Ingredient ("gears",1)}, tab, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0},nil,nil,nil,15)
	pencilR.atlas = "images/inventoryimages/pencil.xml"

	local pencil = Ingredient("pencil", 1, "images/inventoryimages/pencil.xml")

	local status = Recipe("status", {Ingredient("gears", 1), pencil}, tab, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0},nil,nil,nil,15)
	status.atlas = "images/inventoryimages/status.xml"


	return tab 
end

local function tabIt(p,tab)
	if (TUNING.WX78_OVERHAUL == "easy") then
		SCCreate(tab)
	elseif (TUNING.WX78_OVERHAUL == "standard") then
		HCCreate(tab)
	end

	if (p==0) then
		TESTCreate(tab)
	end
end


local fn = function(inst)
	inst.level = 0
	inst.flexibleUpgrades = 0
	inst.health_level = 0
	inst.sanity_level = 0
	inst.hunger_level = 0
	inst.locomotor_level = 0
	inst.combat_level=0
	inst.charge_time = 0
	inst.spark_time = 3
	inst.WX_Current_Run_Speed = TUNING.WILSON_RUN_SPEED
	inst.WX_Max_Sanity = TUNING.WX78_MAX_SANITY
	inst.WX_Max_Health = TUNING.WX78_MAX_HEALTH 

	inst.components.eater.ignoresspoilage = true

	table.insert(inst.components.eater.foodprefs, "HEALTHUP")
	table.insert(inst.components.eater.foodprefs, "SANITYUP")
	table.insert(inst.components.eater.foodprefs, "HUNGERUP")
	table.insert(inst.components.eater.foodprefs, "LOCOMOTORUP")
	table.insert(inst.components.eater.foodprefs, "COMBATUP")
	table.insert(inst.components.eater.foodprefs, "COMBATDOWN")
	table.insert(inst.components.eater.foodprefs, "LOCOMOTORDOWN")

	table.insert(inst.components.eater.ablefoods, "LOCOMOTORDOWN")
	table.insert(inst.components.eater.ablefoods, "COMBATUP")
	table.insert(inst.components.eater.ablefoods, "LOCOMOTORUP")
	table.insert(inst.components.eater.ablefoods, "HUNGERUP")
	table.insert(inst.components.eater.ablefoods, "SANITYUP")
	table.insert(inst.components.eater.ablefoods, "HEALTHUP")
	table.insert(inst.components.eater.ablefoods, "COMBATDOWN")

	inst.components.eater:SetOnEatFn(oneat)
	applyupgrades(inst)
	
	inst:AddComponent("reader")
	
	
	local uptab = {str= STRINGS.TABS.UPGRADES, sort=999, icon = "tab_up.tex"}
	
	inst.components.builder:AddRecipeTab(uptab)
	tabIt(1,uptab)
	
	inst.components.playerlightningtarget:SetHitChance(1)
	inst.components.playerlightningtarget:SetOnStrikeFn(onlightingstrike)
	inst:AddTag("electricdamageimmune") --This is for combat, not lightning strikes

    inst.Light:Enable(false)
	inst.Light:SetRadius(2)
    inst.Light:SetFalloff(0.75)
    inst.Light:SetIntensity(.9)
    inst.Light:SetColour(235/255,121/255,12/255)
	
	inst.OnLongUpdate = function(inst, dt) 
		inst.charge_time = math.max(0, inst.charge_time - dt)
	end

	inst:DoPeriodicTask(1/10, function() dorainsparks(inst, 1/10) end)
	inst.OnSave = onsave
	inst.OnLoad = onload
	inst.OnPreLoad = onpreload
	
end

return MakePlayerCharacter("wx78", prefabs, assets, fn) 
